Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_getstreamvariable.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_getstreamvariable.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_getstreamvariable.php	(revision )
@@ -0,0 +1,51 @@
+<?php
+
+/**
+ * Smarty Method GetStreamVariable
+ *
+ * Smarty::getStreamVariable() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetStreamVariable
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * gets  a stream variable
+     *
+     * @api Smarty::getStreamVariable()
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string                                                 $variable the stream of the variable
+     *
+     * @return mixed
+     * @throws \SmartyException
+     */
+    public function getStreamVariable(Smarty_Internal_Data $data, $variable)
+    {
+        $_result = '';
+        $fp = fopen($variable, 'r+');
+        if ($fp) {
+            while (!feof($fp) && ($current_line = fgets($fp)) !== false) {
+                $_result .= $current_line;
+            }
+            fclose($fp);
+
+            return $_result;
+        }
+        $smarty = isset($data->smarty) ? $data->smarty : $data;
+        if ($smarty->error_unassigned) {
+            throw new SmartyException('Undefined stream variable "' . $variable . '"');
+        } else {
+            return null;
+        }
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcompiledtemplate.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcompiledtemplate.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcompiledtemplate.php	(revision )
@@ -0,0 +1,124 @@
+<?php
+
+/**
+ * Smarty Method ClearCompiledTemplate
+ *
+ * Smarty::clearCompiledTemplate() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ClearCompiledTemplate
+{
+    /**
+     * Valid for Smarty object
+     *
+     * @var int
+     */
+    public $objMap = 1;
+
+    /**
+     * Delete compiled template file
+     *
+     * @api  Smarty::clearCompiledTemplate()
+     * @link http://www.smarty.net/docs/en/api.clear.compiled.template.tpl
+     *
+     * @param \Smarty  $smarty
+     * @param  string  $resource_name template name
+     * @param  string  $compile_id    compile id
+     * @param  integer $exp_time      expiration time
+     *
+     * @return integer number of template files deleted
+     */
+    public function clearCompiledTemplate(Smarty $smarty, $resource_name = null, $compile_id = null, $exp_time = null)
+    {
+
+        $_compile_dir = $smarty->getCompileDir();
+        if ($_compile_dir == '/') { //We should never want to delete this!
+            return 0;
+        }
+        $_compile_id = isset($compile_id) ? preg_replace('![^\w]+!', '_', $compile_id) : null;
+        $_dir_sep = $smarty->use_sub_dirs ? DS : '^';
+        if (isset($resource_name)) {
+            $_save_stat = $smarty->caching;
+            $smarty->caching = false;
+            /* @var Smarty_Internal_Template $tpl */
+            $tpl = new $smarty->template_class($resource_name, $smarty);
+            $smarty->caching = $_save_stat;
+            if ($tpl->source->exists) {
+                // remove from compileds cache
+                $tpl->source->compileds = array();
+                $_resource_part_1 = basename(str_replace('^', DS, $tpl->compiled->filepath));
+                $_resource_part_1_length = strlen($_resource_part_1);
+            } else {
+                return 0;
+            }
+            $_resource_part_2 = str_replace('.php', '.cache.php', $_resource_part_1);
+            $_resource_part_2_length = strlen($_resource_part_2);
+        }
+        $_dir = $_compile_dir;
+        if ($smarty->use_sub_dirs && isset($_compile_id)) {
+            $_dir .= $_compile_id . $_dir_sep;
+        }
+        if (isset($_compile_id)) {
+            $_compile_id_part = $_compile_dir . $_compile_id . $_dir_sep;
+            $_compile_id_part_length = strlen($_compile_id_part);
+        }
+        $_count = 0;
+        try {
+            $_compileDirs = new RecursiveDirectoryIterator($_dir);
+            // NOTE: UnexpectedValueException thrown for PHP >= 5.3
+        }
+        catch (Exception $e) {
+            return 0;
+        }
+        $_compile = new RecursiveIteratorIterator($_compileDirs, RecursiveIteratorIterator::CHILD_FIRST);
+        foreach ($_compile as $_file) {
+            if (substr(basename($_file->getPathname()), 0, 1) == '.' || strpos($_file, '.svn') !== false) {
+                continue;
+            }
+
+            $_filepath = (string) $_file;
+
+            if ($_file->isDir()) {
+                if (!$_compile->isDot()) {
+                    // delete folder if empty
+                    @rmdir($_file->getPathname());
+                }
+            } else {
+                $unlink = false;
+                if ((!isset($_compile_id) || (isset($_filepath[$_compile_id_part_length]) &&
+                            $a = !strncmp($_filepath, $_compile_id_part, $_compile_id_part_length))) &&
+                    (!isset($resource_name) || (isset($_filepath[$_resource_part_1_length]) &&
+                            substr_compare($_filepath, $_resource_part_1, - $_resource_part_1_length,
+                                           $_resource_part_1_length) == 0) ||
+                        (isset($_filepath[$_resource_part_2_length]) &&
+                            substr_compare($_filepath, $_resource_part_2, - $_resource_part_2_length,
+                                           $_resource_part_2_length) == 0))
+                ) {
+                    if (isset($exp_time)) {
+                        if (time() - @filemtime($_filepath) >= $exp_time) {
+                            $unlink = true;
+                        }
+                    } else {
+                        $unlink = true;
+                    }
+                }
+
+                if ($unlink && @unlink($_filepath)) {
+                    $_count ++;
+                    if (function_exists('opcache_invalidate')) {
+                        opcache_invalidate($_filepath);
+                    }
+                }
+            }
+        }
+        // clear template objects cache
+        $smarty->_cache['isCached'] = array();
+        if (isset($smarty->ext->_subtemplate)) {
+            $smarty->ext->_subtemplate->tplObjects = array();
+        }
+        return $_count;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_debug.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_debug.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_debug.php	(revision )
@@ -1,7 +1,7 @@
 <?php
 /**
  * Smarty Internal Plugin Debug
- * Class to collect data for the Smarty Debugging Consol
+ * Class to collect data for the Smarty Debugging Console
  *
  * @package    Smarty
  * @subpackage Debug
@@ -21,166 +21,246 @@
      *
      * @var array
      */
-    public static $template_data = array();
+    public $template_data = array();
 
     /**
      * List of uid's which shall be ignored
      *
      * @var array
      */
-    public static $ignore_uid = array();
+    public $ignore_uid = array();
 
     /**
-     * Ignore template
+     * Index of display() and fetch() calls
      *
-     * @param object $template
+     * @var int
      */
-    public static function ignore($template)
+    public $index = 0;
+
+    /**
+     * Counter for window offset
+     *
+     * @var int
+     */
+    public $offset = 0;
+
+    /**
+     * Start logging template
+     *
+     * @param \Smarty_Internal_Template $template template
+     * @param null                      $mode     true: display   false: fetch  null: subtemplate
+     */
+    public function start_template(Smarty_Internal_Template $template, $mode = null)
     {
-        // calculate Uid if not already done
-        if ($template->source->uid == '') {
-            $template->source->filepath;
+        if (isset($mode)) {
+            $this->index ++;
+            $this->offset ++;
+            $this->template_data[$this->index] = null;
         }
-        self::$ignore_uid[$template->source->uid] = true;
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['start_template_time'] = microtime(true);
     }
 
     /**
+     * End logging of cache time
+     *
+     * @param \Smarty_Internal_Template $template cached template
+     */
+    public function end_template(Smarty_Internal_Template $template)
+    {
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['total_time'] +=
+            microtime(true) - $this->template_data[$this->index][$key]['start_template_time'];
+        //$this->template_data[$this->index][$key]['properties'] = $template->properties;
+    }
+
+    /**
      * Start logging of compile time
      *
-     * @param object $template
+     * @param \Smarty_Internal_Template $template
      */
-    public static function start_compile($template)
+    public function start_compile(Smarty_Internal_Template $template)
     {
         static $_is_stringy = array('string' => true, 'eval' => true);
         if (!empty($template->compiler->trace_uid)) {
             $key = $template->compiler->trace_uid;
-            if (!isset(self::$template_data[$key])) {
+            if (!isset($this->template_data[$this->index][$key])) {
                 if (isset($_is_stringy[$template->source->type])) {
-                    self::$template_data[$key]['name'] = '\'' . substr($template->source->name, 0, 25) . '...\'';
+                    $this->template_data[$this->index][$key]['name'] =
+                        '\'' . substr($template->source->name, 0, 25) . '...\'';
                 } else {
-                    self::$template_data[$key]['name'] = $template->source->filepath;
+                    $this->template_data[$this->index][$key]['name'] = $template->source->filepath;
                 }
-                self::$template_data[$key]['compile_time'] = 0;
-                self::$template_data[$key]['render_time'] = 0;
-                self::$template_data[$key]['cache_time'] = 0;
+                $this->template_data[$this->index][$key]['compile_time'] = 0;
+                $this->template_data[$this->index][$key]['render_time'] = 0;
+                $this->template_data[$this->index][$key]['cache_time'] = 0;
             }
         } else {
-            if (isset(self::$ignore_uid[$template->source->uid])) {
+            if (isset($this->ignore_uid[$template->source->uid])) {
                 return;
             }
-            $key = self::get_key($template);
+            $key = $this->get_key($template);
         }
-        self::$template_data[$key]['start_time'] = microtime(true);
+        $this->template_data[$this->index][$key]['start_time'] = microtime(true);
     }
 
     /**
      * End logging of compile time
      *
-     * @param object $template
+     * @param \Smarty_Internal_Template $template
      */
-    public static function end_compile($template)
+    public function end_compile(Smarty_Internal_Template $template)
     {
         if (!empty($template->compiler->trace_uid)) {
             $key = $template->compiler->trace_uid;
         } else {
-            if (isset(self::$ignore_uid[$template->source->uid])) {
+            if (isset($this->ignore_uid[$template->source->uid])) {
                 return;
             }
 
-            $key = self::get_key($template);
+            $key = $this->get_key($template);
         }
-        self::$template_data[$key]['compile_time'] += microtime(true) - self::$template_data[$key]['start_time'];
+        $this->template_data[$this->index][$key]['compile_time'] +=
+            microtime(true) - $this->template_data[$this->index][$key]['start_time'];
     }
 
     /**
      * Start logging of render time
      *
-     * @param object $template
+     * @param \Smarty_Internal_Template $template
      */
-    public static function start_render($template)
+    public function start_render(Smarty_Internal_Template $template)
     {
-        $key = self::get_key($template);
-        self::$template_data[$key]['start_time'] = microtime(true);
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['start_time'] = microtime(true);
     }
 
     /**
      * End logging of compile time
      *
-     * @param object $template
+     * @param \Smarty_Internal_Template $template
      */
-    public static function end_render($template)
+    public function end_render(Smarty_Internal_Template $template)
     {
-        $key = self::get_key($template);
-        self::$template_data[$key]['render_time'] += microtime(true) - self::$template_data[$key]['start_time'];
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['render_time'] +=
+            microtime(true) - $this->template_data[$this->index][$key]['start_time'];
     }
 
     /**
      * Start logging of cache time
      *
-     * @param object $template cached template
+     * @param \Smarty_Internal_Template $template cached template
      */
-    public static function start_cache($template)
+    public function start_cache(Smarty_Internal_Template $template)
     {
-        $key = self::get_key($template);
-        self::$template_data[$key]['start_time'] = microtime(true);
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['start_time'] = microtime(true);
     }
 
     /**
      * End logging of cache time
      *
-     * @param object $template cached template
+     * @param \Smarty_Internal_Template $template cached template
      */
-    public static function end_cache($template)
+    public function end_cache(Smarty_Internal_Template $template)
     {
-        $key = self::get_key($template);
-        self::$template_data[$key]['cache_time'] += microtime(true) - self::$template_data[$key]['start_time'];
+        $key = $this->get_key($template);
+        $this->template_data[$this->index][$key]['cache_time'] +=
+            microtime(true) - $this->template_data[$this->index][$key]['start_time'];
     }
 
     /**
-     * Opens a window for the Smarty Debugging Consol and display the data
+     * Register template object
      *
+     * @param \Smarty_Internal_Template $template cached template
+     */
+    public function register_template(Smarty_Internal_Template $template)
+    {
+    }
+
+    /**
+     * Register data object
+     *
+     * @param \Smarty_Data $data data object
+     */
+    public static function register_data(Smarty_Data $data)
+    {
+    }
+
+    /**
+     * Opens a window for the Smarty Debugging Console and display the data
+     *
      * @param Smarty_Internal_Template|Smarty $obj object to debug
+     * @param bool                            $full
      */
-    public static function display_debug($obj)
+    public function display_debug($obj, $full = false)
     {
-        // prepare information of assigned variables
-        $ptr = self::get_debug_vars($obj);
-        if ($obj instanceof Smarty) {
-            $smarty = clone $obj;
+        if (!$full) {
+            $this->offset ++;
+            $savedIndex = $this->index;
+            $this->index = 9999;
+        }
+        if ($obj->_objType == 1) {
+            $smarty = $obj;
         } else {
-            $smarty = clone $obj->smarty;
+            $smarty = $obj->smarty;
         }
+        // create fresh instance of smarty for displaying the debug console
+        // to avoid problems if the application did overload the Smarty class
+        $debObj = new Smarty();
+        // copy the working dirs from application
+        $debObj->setCompileDir($smarty->getCompileDir());
+        // init properties by hand as user may have edited the original Smarty class
+        $debObj->setPluginsDir(is_dir(__DIR__ . '/../plugins') ? __DIR__ . '/../plugins' : $smarty->getPluginsDir());
+        $debObj->force_compile = false;
+        $debObj->compile_check = true;
+        $debObj->left_delimiter = '{';
+        $debObj->right_delimiter = '}';
+        $debObj->security_policy = null;
+        $debObj->debugging = false;
+        $debObj->debugging_ctrl = 'NONE';
+        $debObj->error_reporting = E_ALL & ~E_NOTICE;
+        $debObj->debug_tpl = isset($smarty->debug_tpl) ? $smarty->debug_tpl : 'file:' . __DIR__ . '/../debug.tpl';
+        $debObj->registered_plugins = array();
+        $debObj->registered_resources = array();
+        $debObj->registered_filters = array();
+        $debObj->autoload_filters = array();
+        $debObj->default_modifiers = array();
+        $debObj->escape_html = true;
+        $debObj->caching = false;
+        $debObj->compile_id = null;
+        $debObj->cache_id = null;
+        // prepare information of assigned variables
+        $ptr = $this->get_debug_vars($obj);
         $_assigned_vars = $ptr->tpl_vars;
         ksort($_assigned_vars);
         $_config_vars = $ptr->config_vars;
         ksort($_config_vars);
-        $smarty->registered_filters = array();
-        $smarty->autoload_filters = array();
-        $smarty->default_modifiers = array();
-        $smarty->force_compile = false;
-        $smarty->left_delimiter = '{';
-        $smarty->right_delimiter = '}';
-        $smarty->debugging = false;
-        $smarty->debugging_ctrl = 'NONE';
-        $smarty->force_compile = false;
-        $_template = new Smarty_Internal_Template($smarty->debug_tpl, $smarty);
-        $_template->caching = false;
-        $_template->disableSecurity();
-        $_template->cache_id = null;
-        $_template->compile_id = null;
-        if ($obj instanceof Smarty_Internal_Template) {
+        $debugging = $smarty->debugging;
+
+        $_template = new Smarty_Internal_Template($debObj->debug_tpl, $debObj);
+        if ($obj->_objType == 2) {
             $_template->assign('template_name', $obj->source->type . ':' . $obj->source->name);
         }
-        if ($obj instanceof Smarty) {
-            $_template->assign('template_data', self::$template_data);
+        if ($obj->_objType == 1 || $full) {
+            $_template->assign('template_data', $this->template_data[$this->index]);
         } else {
             $_template->assign('template_data', null);
         }
         $_template->assign('assigned_vars', $_assigned_vars);
         $_template->assign('config_vars', $_config_vars);
         $_template->assign('execution_time', microtime(true) - $smarty->start_time);
+        $_template->assign('display_mode', $debugging == 2 || !$full);
+        $_template->assign('offset', $this->offset * 50);
         echo $_template->fetch();
+        if (isset($full)) {
+            $this->index --;
-    }
+        }
+        if (!$full) {
+            $this->index = $savedIndex;
+        }
+    }
 
     /**
      * Recursively gets variables from all template/data scopes
@@ -189,34 +269,82 @@
      *
      * @return StdClass
      */
-    public static function get_debug_vars($obj)
+    public function get_debug_vars($obj)
     {
-        $config_vars = $obj->config_vars;
+        $config_vars = array();
+        foreach ($obj->config_vars as $key => $var) {
+            $config_vars[$key]['value'] = $var;
+            if ($obj->_objType == 2) {
+                $config_vars[$key]['scope'] = $obj->source->type . ':' . $obj->source->name;
+            } elseif ($obj->_objType == 4) {
+                $tpl_vars[$key]['scope'] = $obj->dataObjectName;
+            } else {
+                $config_vars[$key]['scope'] = 'Smarty object';
+            }
+        }
         $tpl_vars = array();
         foreach ($obj->tpl_vars as $key => $var) {
-            $tpl_vars[$key] = clone $var;
-            if ($obj instanceof Smarty_Internal_Template) {
-                $tpl_vars[$key]->scope = $obj->source->type . ':' . $obj->source->name;
-            } elseif ($obj instanceof Smarty_Data) {
-                $tpl_vars[$key]->scope = 'Data object';
+            foreach ($var as $varkey => $varvalue) {
+                if ($varkey == 'value') {
+                    $tpl_vars[$key][$varkey] = $varvalue;
-            } else {
+                } else {
-                $tpl_vars[$key]->scope = 'Smarty root';
+                    if ($varkey == 'nocache') {
+                        if ($varvalue == true) {
+                            $tpl_vars[$key][$varkey] = $varvalue;
-            }
+                        }
+                    } else {
+                        if ($varkey != 'scope' || $varvalue !== 0) {
+                            $tpl_vars[$key]['attributes'][$varkey] = $varvalue;
-        }
+                        }
+                    }
+                }
+            }
+            if ($obj->_objType == 2) {
+                $tpl_vars[$key]['scope'] = $obj->source->type . ':' . $obj->source->name;
+            } elseif ($obj->_objType == 4) {
+                $tpl_vars[$key]['scope'] = $obj->dataObjectName;
+            } else {
+                $tpl_vars[$key]['scope'] = 'Smarty object';
+            }
+        }
 
         if (isset($obj->parent)) {
-            $parent = self::get_debug_vars($obj->parent);
+            $parent = $this->get_debug_vars($obj->parent);
+            foreach ($parent->tpl_vars as $name => $pvar) {
+                if (isset($tpl_vars[$name]) && $tpl_vars[$name]['value'] === $pvar['value']) {
+                    $tpl_vars[$name]['scope'] = $pvar['scope'];
+                }
+            }
             $tpl_vars = array_merge($parent->tpl_vars, $tpl_vars);
+
+            foreach ($parent->config_vars as $name => $pvar) {
+                if (isset($config_vars[$name]) && $config_vars[$name]['value'] === $pvar['value']) {
+                    $config_vars[$name]['scope'] = $pvar['scope'];
+                }
+            }
             $config_vars = array_merge($parent->config_vars, $config_vars);
         } else {
-            foreach (Smarty::$global_tpl_vars as $name => $var) {
-                if (!array_key_exists($name, $tpl_vars)) {
-                    $clone = clone $var;
-                    $clone->scope = 'Global';
-                    $tpl_vars[$name] = $clone;
+            foreach (Smarty::$global_tpl_vars as $key => $var) {
+                if (!array_key_exists($key, $tpl_vars)) {
+                    foreach ($var as $varkey => $varvalue) {
+                        if ($varkey == 'value') {
+                            $tpl_vars[$key][$varkey] = $varvalue;
+                        } else {
+                            if ($varkey == 'nocache') {
+                                if ($varvalue == true) {
+                                    $tpl_vars[$key][$varkey] = $varvalue;
-                }
+                                }
+                            } else {
+                                if ($varkey != 'scope' || $varvalue !== 0) {
+                                    $tpl_vars[$key]['attributes'][$varkey] = $varvalue;
-            }
-        }
+                                }
+                            }
+                        }
+                    }
+                    $tpl_vars[$key]['scope'] = 'Global';
+                }
+            }
+        }
 
         return (object) array('tpl_vars' => $tpl_vars, 'config_vars' => $config_vars);
     }
@@ -224,11 +352,11 @@
     /**
      * Return key into $template_data for template
      *
-     * @param  object $template template object
+     * @param \Smarty_Internal_Template $template template object
      *
      * @return string key into $template_data
      */
-    private static function get_key($template)
+    private function get_key(Smarty_Internal_Template $template)
     {
         static $_is_stringy = array('string' => true, 'eval' => true);
         // calculate Uid if not already done
@@ -236,19 +364,67 @@
             $template->source->filepath;
         }
         $key = $template->source->uid;
-        if (isset(self::$template_data[$key])) {
+        if (isset($this->template_data[$this->index][$key])) {
             return $key;
         } else {
             if (isset($_is_stringy[$template->source->type])) {
-                self::$template_data[$key]['name'] = '\'' . substr($template->source->name, 0, 25) . '...\'';
+                $this->template_data[$this->index][$key]['name'] =
+                    '\'' . substr($template->source->name, 0, 25) . '...\'';
             } else {
-                self::$template_data[$key]['name'] = $template->source->filepath;
+                $this->template_data[$this->index][$key]['name'] = $template->source->filepath;
             }
-            self::$template_data[$key]['compile_time'] = 0;
-            self::$template_data[$key]['render_time'] = 0;
-            self::$template_data[$key]['cache_time'] = 0;
+            $this->template_data[$this->index][$key]['compile_time'] = 0;
+            $this->template_data[$this->index][$key]['render_time'] = 0;
+            $this->template_data[$this->index][$key]['cache_time'] = 0;
+            $this->template_data[$this->index][$key]['total_time'] = 0;
 
             return $key;
+        }
+    }
+
+    /**
+     * Ignore template
+     *
+     * @param \Smarty_Internal_Template $template
+     */
+    public function ignore(Smarty_Internal_Template $template)
+    {
+        // calculate Uid if not already done
+        if ($template->source->uid == '') {
+            $template->source->filepath;
+        }
+        $this->ignore_uid[$template->source->uid] = true;
+    }
+
+    /**
+     * handle 'URL' debugging mode
+     *
+     * @param Smarty $smarty
+     */
+    public function debugUrl(Smarty $smarty)
+    {
+        if (isset($_SERVER['QUERY_STRING'])) {
+            $_query_string = $_SERVER['QUERY_STRING'];
+        } else {
+            $_query_string = '';
+        }
+        if (false !== strpos($_query_string, $smarty->smarty_debug_id)) {
+            if (false !== strpos($_query_string, $smarty->smarty_debug_id . '=on')) {
+                // enable debugging for this browser session
+                setcookie('SMARTY_DEBUG', true);
+                $smarty->debugging = true;
+            } elseif (false !== strpos($_query_string, $smarty->smarty_debug_id . '=off')) {
+                // disable debugging for this browser session
+                setcookie('SMARTY_DEBUG', false);
+                $smarty->debugging = false;
+            } else {
+                // enable debugging for this page
+                $smarty->debugging = true;
+            }
+        } else {
+            if (isset($_COOKIE['SMARTY_DEBUG'])) {
+                $smarty->debugging = true;
+            }
         }
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultconfighandler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultconfighandler.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultconfighandler.php	(revision )
@@ -0,0 +1,42 @@
+<?php
+
+/**
+ * Smarty Method RegisterDefaultConfigHandler
+ *
+ * Smarty::registerDefaultConfigHandler() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterDefaultConfigHandler
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Register config default handler
+     *
+     * @api  Smarty::registerDefaultConfigHandler()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  callable                                                       $callback class/method name
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException              if $callback is not callable
+     */
+    public function registerDefaultConfigHandler(Smarty_Internal_TemplateBase $obj, $callback)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (is_callable($callback)) {
+            $smarty->default_config_handler_func = $callback;
+        } else {
+            throw new SmartyException("Default config handler not callable");
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_nocache_insert.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_nocache_insert.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_nocache_insert.php	(revision )
@@ -42,10 +42,10 @@
             $_output .= "echo {$_function}(" . var_export($_attr, true) . ",\$_smarty_tpl);?>";
         }
         $_tpl = $_template;
-        while ($_tpl->parent instanceof Smarty_Internal_Template) {
+        while (isset($_tpl->parent) && $_tpl->parent->_objType == 2) {
             $_tpl = $_tpl->parent;
         }
 
-        return "/*%%SmartyNocache:{$_tpl->properties['nocache_hash']}%%*/" . $_output . "/*/%%SmartyNocache:{$_tpl->properties['nocache_hash']}%%*/";
+        return "/*%%SmartyNocache:{$_tpl->compiled->nocache_hash}%%*/" . $_output . "/*/%%SmartyNocache:{$_tpl->compiled->nocache_hash}%%*/";
     }
 }
